mod cli;

use cli::get_input;
use georgeemu::GeorgeEmu;
use minifb::{Scale, ScaleMode, Window, WindowOptions};

fn main() {
    let mut window = Window::new(
        "ʕ·ᴥ·ʔ-☆",
        512,
        380,
        WindowOptions {
            resize: true,
            borderless: true,
            title: true,
            transparency: false,
            scale: Scale::FitScreen,
            scale_mode: ScaleMode::AspectRatioStretch,
            topmost: false,
            none: true,
        },
    )
    .unwrap();
    let config = get_input();
    #[cfg(not(feature = "term"))]
    let mut emu = GeorgeEmu::builder()
        .window(&mut window)
        .rom("/Users/august/projects/george-emu/src/roms/demo.rom")
        .build();
    #[cfg(feature = "term")]
    let mut emu = GeorgeEmu::builder().build();
    emu.run();
}
